<?php
require_once( dirname(__FILE__) . DIRECTORY_SEPARATOR . "/main.inc");
session_start();
if (isset($_SESSION['app_errors'])) {
	$_SESSION['app_errors'] = array();
}
doAction();
doAuth();
if (isAuthed())
	getNotebooks();
?>

<html>
<head>
	<title>Evernote: Sample Application Using OAuth</title>
	<script type="text/javascript" src="main.js"></script>
	<link rel="stylesheet" type="text/css" media="all" href="main.css" />
</head>
<body onLoad="doOnLoad();">
<center>
<div id="content" style="display:none;">
	<h1>Sample Evernote App</h1>
	<p>This is a simple demonstration of how to access data from Evernote via OAuth.</p>
	<p>If OAuth authentication has been established, you will see a list of user's notebooks.
	Otherwise, you must authorize this application to access data from Evernote using the button below.</p>
	<hr/>

	<?php if (hasErrors()): ?>
		<ul class="appErrors">
		<?php foreach ($_SESSION['app_errors'] as $err): ?>
			<li><?php echo $err->message ?></li>
		<?php endforeach; ?>
		</ul><br/>
	<?php endif; ?>
	
	<?php if (!isAuthed()) { ?>
	<p>Please 
		<a href="<?php echo getAuthUrl() ?>" target="authEvernote" onClick="setTimeout('openAuthDialog()', 1000)">authorize</a> 
		<b>"<?php echo consumerName?>"</b> to access your Evernote account.
	</p>
	
	<?php } else { ?>
	<div id="listNotebooks">
		<h2>List of notebooks:</h2>
		<ul>
		<?php foreach (getNotebooks() as $notebook):?>
			<li><?php echo $notebook->name; ?></li>
		<?php endforeach; ?>
		</ul>
	</div>
	<?php } ?>
	
	<?php if (isAuthed()): ?>
	<br/>
	<a href="<?php echo $_SERVER['SCRIPT_NAME'] . "?action=resetSession" ?>">Reset</a>
	<?php endif; ?>
	
	<div id="veil" style="display: none;"></div>
	<div id="authDialog" style="display: none;">
		<iframe id="authFrame" name="authEvernote" scrolling=no src="about:blank"></iframe>
	</div>
	
</div> <!-- /content -->
</center>
<script type="text/javascript">
	showBlock("content");
</script>
</body>
</html>
