/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Thrift;
using Thrift.Collections;
using Thrift.Protocol;
using Thrift.Transport;
namespace Evernote.EDAM.UserStore
{
  public class UserStore {
    public interface Iface {
      bool checkVersion(string clientName, short edamVersionMajor, short edamVersionMinor);
      AuthenticationResult authenticate(string username, string password, string consumerKey, string consumerSecret);
      AuthenticationResult refreshAuthentication(string authenticationToken);
      Evernote.EDAM.Type.User getUser(string authenticationToken);
      PublicUserInfo getPublicUserInfo(string username);
    }

    public class Client : Iface {
      public Client(TProtocol prot) : this(prot, prot)
      {
      }

      public Client(TProtocol iprot, TProtocol oprot)
      {
        iprot_ = iprot;
        oprot_ = oprot;
      }

      protected TProtocol iprot_;
      protected TProtocol oprot_;
      protected int seqid_;

      public TProtocol InputProtocol
      {
        get { return iprot_; }
      }
      public TProtocol OutputProtocol
      {
        get { return oprot_; }
      }


      public bool checkVersion(string clientName, short edamVersionMajor, short edamVersionMinor)
      {
        send_checkVersion(clientName, edamVersionMajor, edamVersionMinor);
        return recv_checkVersion();
      }

      public void send_checkVersion(string clientName, short edamVersionMajor, short edamVersionMinor)
      {
        oprot_.WriteMessageBegin(new TMessage("checkVersion", TMessageType.Call, seqid_));
        checkVersion_args args = new checkVersion_args();
        args.ClientName = clientName;
        args.EdamVersionMajor = edamVersionMajor;
        args.EdamVersionMinor = edamVersionMinor;
        args.Write(oprot_);
        oprot_.WriteMessageEnd();
        oprot_.Transport.Flush();
      }

      public bool recv_checkVersion()
      {
        TMessage msg = iprot_.ReadMessageBegin();
        if (msg.Type == TMessageType.Exception) {
          TApplicationException x = TApplicationException.Read(iprot_);
          iprot_.ReadMessageEnd();
          throw x;
        }
        checkVersion_result result = new checkVersion_result();
        result.Read(iprot_);
        iprot_.ReadMessageEnd();
        if (result.__isset.success) {
          return result.Success;
        }
        throw new TApplicationException(TApplicationException.ExceptionType.MissingResult, "checkVersion failed: unknown result");
      }

      public AuthenticationResult authenticate(string username, string password, string consumerKey, string consumerSecret)
      {
        send_authenticate(username, password, consumerKey, consumerSecret);
        return recv_authenticate();
      }

      public void send_authenticate(string username, string password, string consumerKey, string consumerSecret)
      {
        oprot_.WriteMessageBegin(new TMessage("authenticate", TMessageType.Call, seqid_));
        authenticate_args args = new authenticate_args();
        args.Username = username;
        args.Password = password;
        args.ConsumerKey = consumerKey;
        args.ConsumerSecret = consumerSecret;
        args.Write(oprot_);
        oprot_.WriteMessageEnd();
        oprot_.Transport.Flush();
      }

      public AuthenticationResult recv_authenticate()
      {
        TMessage msg = iprot_.ReadMessageBegin();
        if (msg.Type == TMessageType.Exception) {
          TApplicationException x = TApplicationException.Read(iprot_);
          iprot_.ReadMessageEnd();
          throw x;
        }
        authenticate_result result = new authenticate_result();
        result.Read(iprot_);
        iprot_.ReadMessageEnd();
        if (result.__isset.success) {
          return result.Success;
        }
        if (result.__isset.userException) {
          throw result.UserException;
        }
        if (result.__isset.systemException) {
          throw result.SystemException;
        }
        throw new TApplicationException(TApplicationException.ExceptionType.MissingResult, "authenticate failed: unknown result");
      }

      public AuthenticationResult refreshAuthentication(string authenticationToken)
      {
        send_refreshAuthentication(authenticationToken);
        return recv_refreshAuthentication();
      }

      public void send_refreshAuthentication(string authenticationToken)
      {
        oprot_.WriteMessageBegin(new TMessage("refreshAuthentication", TMessageType.Call, seqid_));
        refreshAuthentication_args args = new refreshAuthentication_args();
        args.AuthenticationToken = authenticationToken;
        args.Write(oprot_);
        oprot_.WriteMessageEnd();
        oprot_.Transport.Flush();
      }

      public AuthenticationResult recv_refreshAuthentication()
      {
        TMessage msg = iprot_.ReadMessageBegin();
        if (msg.Type == TMessageType.Exception) {
          TApplicationException x = TApplicationException.Read(iprot_);
          iprot_.ReadMessageEnd();
          throw x;
        }
        refreshAuthentication_result result = new refreshAuthentication_result();
        result.Read(iprot_);
        iprot_.ReadMessageEnd();
        if (result.__isset.success) {
          return result.Success;
        }
        if (result.__isset.userException) {
          throw result.UserException;
        }
        if (result.__isset.systemException) {
          throw result.SystemException;
        }
        throw new TApplicationException(TApplicationException.ExceptionType.MissingResult, "refreshAuthentication failed: unknown result");
      }

      public Evernote.EDAM.Type.User getUser(string authenticationToken)
      {
        send_getUser(authenticationToken);
        return recv_getUser();
      }

      public void send_getUser(string authenticationToken)
      {
        oprot_.WriteMessageBegin(new TMessage("getUser", TMessageType.Call, seqid_));
        getUser_args args = new getUser_args();
        args.AuthenticationToken = authenticationToken;
        args.Write(oprot_);
        oprot_.WriteMessageEnd();
        oprot_.Transport.Flush();
      }

      public Evernote.EDAM.Type.User recv_getUser()
      {
        TMessage msg = iprot_.ReadMessageBegin();
        if (msg.Type == TMessageType.Exception) {
          TApplicationException x = TApplicationException.Read(iprot_);
          iprot_.ReadMessageEnd();
          throw x;
        }
        getUser_result result = new getUser_result();
        result.Read(iprot_);
        iprot_.ReadMessageEnd();
        if (result.__isset.success) {
          return result.Success;
        }
        if (result.__isset.userException) {
          throw result.UserException;
        }
        if (result.__isset.systemException) {
          throw result.SystemException;
        }
        throw new TApplicationException(TApplicationException.ExceptionType.MissingResult, "getUser failed: unknown result");
      }

      public PublicUserInfo getPublicUserInfo(string username)
      {
        send_getPublicUserInfo(username);
        return recv_getPublicUserInfo();
      }

      public void send_getPublicUserInfo(string username)
      {
        oprot_.WriteMessageBegin(new TMessage("getPublicUserInfo", TMessageType.Call, seqid_));
        getPublicUserInfo_args args = new getPublicUserInfo_args();
        args.Username = username;
        args.Write(oprot_);
        oprot_.WriteMessageEnd();
        oprot_.Transport.Flush();
      }

      public PublicUserInfo recv_getPublicUserInfo()
      {
        TMessage msg = iprot_.ReadMessageBegin();
        if (msg.Type == TMessageType.Exception) {
          TApplicationException x = TApplicationException.Read(iprot_);
          iprot_.ReadMessageEnd();
          throw x;
        }
        getPublicUserInfo_result result = new getPublicUserInfo_result();
        result.Read(iprot_);
        iprot_.ReadMessageEnd();
        if (result.__isset.success) {
          return result.Success;
        }
        if (result.__isset.notFoundException) {
          throw result.NotFoundException;
        }
        if (result.__isset.systemException) {
          throw result.SystemException;
        }
        if (result.__isset.userException) {
          throw result.UserException;
        }
        throw new TApplicationException(TApplicationException.ExceptionType.MissingResult, "getPublicUserInfo failed: unknown result");
      }

    }
    public class Processor : TProcessor {
      public Processor(Iface iface)
      {
        iface_ = iface;
        processMap_["checkVersion"] = checkVersion_Process;
        processMap_["authenticate"] = authenticate_Process;
        processMap_["refreshAuthentication"] = refreshAuthentication_Process;
        processMap_["getUser"] = getUser_Process;
        processMap_["getPublicUserInfo"] = getPublicUserInfo_Process;
      }

      protected delegate void ProcessFunction(int seqid, TProtocol iprot, TProtocol oprot);
      private Iface iface_;
      protected Dictionary<string, ProcessFunction> processMap_ = new Dictionary<string, ProcessFunction>();

      public bool Process(TProtocol iprot, TProtocol oprot)
      {
        try
        {
          TMessage msg = iprot.ReadMessageBegin();
          ProcessFunction fn;
          processMap_.TryGetValue(msg.Name, out fn);
          if (fn == null) {
            TProtocolUtil.Skip(iprot, TType.Struct);
            iprot.ReadMessageEnd();
            TApplicationException x = new TApplicationException (TApplicationException.ExceptionType.UnknownMethod, "Invalid method name: '" + msg.Name + "'");
            oprot.WriteMessageBegin(new TMessage(msg.Name, TMessageType.Exception, msg.SeqID));
            x.Write(oprot);
            oprot.WriteMessageEnd();
            oprot.Transport.Flush();
            return true;
          }
          fn(msg.SeqID, iprot, oprot);
        }
        catch (IOException)
        {
          return false;
        }
        return true;
      }

      public void checkVersion_Process(int seqid, TProtocol iprot, TProtocol oprot)
      {
        checkVersion_args args = new checkVersion_args();
        args.Read(iprot);
        iprot.ReadMessageEnd();
        checkVersion_result result = new checkVersion_result();
        result.Success = iface_.checkVersion(args.ClientName, args.EdamVersionMajor, args.EdamVersionMinor);
        oprot.WriteMessageBegin(new TMessage("checkVersion", TMessageType.Reply, seqid)); 
        result.Write(oprot);
        oprot.WriteMessageEnd();
        oprot.Transport.Flush();
      }

      public void authenticate_Process(int seqid, TProtocol iprot, TProtocol oprot)
      {
        authenticate_args args = new authenticate_args();
        args.Read(iprot);
        iprot.ReadMessageEnd();
        authenticate_result result = new authenticate_result();
        try {
          result.Success = iface_.authenticate(args.Username, args.Password, args.ConsumerKey, args.ConsumerSecret);
        } catch (Evernote.EDAM.Error.EDAMUserException userException) {
          result.UserException = userException;
        } catch (Evernote.EDAM.Error.EDAMSystemException systemException) {
          result.SystemException = systemException;
        }
        oprot.WriteMessageBegin(new TMessage("authenticate", TMessageType.Reply, seqid)); 
        result.Write(oprot);
        oprot.WriteMessageEnd();
        oprot.Transport.Flush();
      }

      public void refreshAuthentication_Process(int seqid, TProtocol iprot, TProtocol oprot)
      {
        refreshAuthentication_args args = new refreshAuthentication_args();
        args.Read(iprot);
        iprot.ReadMessageEnd();
        refreshAuthentication_result result = new refreshAuthentication_result();
        try {
          result.Success = iface_.refreshAuthentication(args.AuthenticationToken);
        } catch (Evernote.EDAM.Error.EDAMUserException userException) {
          result.UserException = userException;
        } catch (Evernote.EDAM.Error.EDAMSystemException systemException) {
          result.SystemException = systemException;
        }
        oprot.WriteMessageBegin(new TMessage("refreshAuthentication", TMessageType.Reply, seqid)); 
        result.Write(oprot);
        oprot.WriteMessageEnd();
        oprot.Transport.Flush();
      }

      public void getUser_Process(int seqid, TProtocol iprot, TProtocol oprot)
      {
        getUser_args args = new getUser_args();
        args.Read(iprot);
        iprot.ReadMessageEnd();
        getUser_result result = new getUser_result();
        try {
          result.Success = iface_.getUser(args.AuthenticationToken);
        } catch (Evernote.EDAM.Error.EDAMUserException userException) {
          result.UserException = userException;
        } catch (Evernote.EDAM.Error.EDAMSystemException systemException) {
          result.SystemException = systemException;
        }
        oprot.WriteMessageBegin(new TMessage("getUser", TMessageType.Reply, seqid)); 
        result.Write(oprot);
        oprot.WriteMessageEnd();
        oprot.Transport.Flush();
      }

      public void getPublicUserInfo_Process(int seqid, TProtocol iprot, TProtocol oprot)
      {
        getPublicUserInfo_args args = new getPublicUserInfo_args();
        args.Read(iprot);
        iprot.ReadMessageEnd();
        getPublicUserInfo_result result = new getPublicUserInfo_result();
        try {
          result.Success = iface_.getPublicUserInfo(args.Username);
        } catch (Evernote.EDAM.Error.EDAMNotFoundException notFoundException) {
          result.NotFoundException = notFoundException;
        } catch (Evernote.EDAM.Error.EDAMSystemException systemException) {
          result.SystemException = systemException;
        } catch (Evernote.EDAM.Error.EDAMUserException userException) {
          result.UserException = userException;
        }
        oprot.WriteMessageBegin(new TMessage("getPublicUserInfo", TMessageType.Reply, seqid)); 
        result.Write(oprot);
        oprot.WriteMessageEnd();
        oprot.Transport.Flush();
      }

    }


    [Serializable]
    public partial class checkVersion_args : TBase
    {
      private string clientName;
      private short edamVersionMajor;
      private short edamVersionMinor;

      public string ClientName
      {
        get
        {
          return clientName;
        }
        set
        {
          __isset.clientName = true;
          this.clientName = value;
        }
      }

      public short EdamVersionMajor
      {
        get
        {
          return edamVersionMajor;
        }
        set
        {
          __isset.edamVersionMajor = true;
          this.edamVersionMajor = value;
        }
      }

      public short EdamVersionMinor
      {
        get
        {
          return edamVersionMinor;
        }
        set
        {
          __isset.edamVersionMinor = true;
          this.edamVersionMinor = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool clientName;
        public bool edamVersionMajor;
        public bool edamVersionMinor;
      }

      public checkVersion_args() {
        this.edamVersionMajor = 1;
        this.edamVersionMinor = 15;
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 1:
              if (field.Type == TType.String) {
                this.clientName = iprot.ReadString();
                this.__isset.clientName = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.I16) {
                this.edamVersionMajor = iprot.ReadI16();
                this.__isset.edamVersionMajor = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 3:
              if (field.Type == TType.I16) {
                this.edamVersionMinor = iprot.ReadI16();
                this.__isset.edamVersionMinor = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("checkVersion_args");
        oprot.WriteStructBegin(struc);
        TField field = new TField();
        if (this.clientName != null && __isset.clientName) {
          field.Name = "clientName";
          field.Type = TType.String;
          field.ID = 1;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.clientName);
          oprot.WriteFieldEnd();
        }
        if (__isset.edamVersionMajor) {
          field.Name = "edamVersionMajor";
          field.Type = TType.I16;
          field.ID = 2;
          oprot.WriteFieldBegin(field);
          oprot.WriteI16(this.edamVersionMajor);
          oprot.WriteFieldEnd();
        }
        if (__isset.edamVersionMinor) {
          field.Name = "edamVersionMinor";
          field.Type = TType.I16;
          field.ID = 3;
          oprot.WriteFieldBegin(field);
          oprot.WriteI16(this.edamVersionMinor);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("checkVersion_args(");
        sb.Append("clientName: ");
        sb.Append(this.clientName);
        sb.Append(",edamVersionMajor: ");
        sb.Append(this.edamVersionMajor);
        sb.Append(",edamVersionMinor: ");
        sb.Append(this.edamVersionMinor);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class checkVersion_result : TBase
    {
      private bool success;

      public bool Success
      {
        get
        {
          return success;
        }
        set
        {
          __isset.success = true;
          this.success = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool success;
      }

      public checkVersion_result() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 0:
              if (field.Type == TType.Bool) {
                this.success = iprot.ReadBool();
                this.__isset.success = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("checkVersion_result");
        oprot.WriteStructBegin(struc);
        TField field = new TField();

        if (this.__isset.success) {
          field.Name = "success";
          field.Type = TType.Bool;
          field.ID = 0;
          oprot.WriteFieldBegin(field);
          oprot.WriteBool(this.success);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("checkVersion_result(");
        sb.Append("success: ");
        sb.Append(this.success);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class authenticate_args : TBase
    {
      private string username;
      private string password;
      private string consumerKey;
      private string consumerSecret;

      public string Username
      {
        get
        {
          return username;
        }
        set
        {
          __isset.username = true;
          this.username = value;
        }
      }

      public string Password
      {
        get
        {
          return password;
        }
        set
        {
          __isset.password = true;
          this.password = value;
        }
      }

      public string ConsumerKey
      {
        get
        {
          return consumerKey;
        }
        set
        {
          __isset.consumerKey = true;
          this.consumerKey = value;
        }
      }

      public string ConsumerSecret
      {
        get
        {
          return consumerSecret;
        }
        set
        {
          __isset.consumerSecret = true;
          this.consumerSecret = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool username;
        public bool password;
        public bool consumerKey;
        public bool consumerSecret;
      }

      public authenticate_args() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 1:
              if (field.Type == TType.String) {
                this.username = iprot.ReadString();
                this.__isset.username = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.String) {
                this.password = iprot.ReadString();
                this.__isset.password = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 3:
              if (field.Type == TType.String) {
                this.consumerKey = iprot.ReadString();
                this.__isset.consumerKey = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 4:
              if (field.Type == TType.String) {
                this.consumerSecret = iprot.ReadString();
                this.__isset.consumerSecret = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("authenticate_args");
        oprot.WriteStructBegin(struc);
        TField field = new TField();
        if (this.username != null && __isset.username) {
          field.Name = "username";
          field.Type = TType.String;
          field.ID = 1;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.username);
          oprot.WriteFieldEnd();
        }
        if (this.password != null && __isset.password) {
          field.Name = "password";
          field.Type = TType.String;
          field.ID = 2;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.password);
          oprot.WriteFieldEnd();
        }
        if (this.consumerKey != null && __isset.consumerKey) {
          field.Name = "consumerKey";
          field.Type = TType.String;
          field.ID = 3;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.consumerKey);
          oprot.WriteFieldEnd();
        }
        if (this.consumerSecret != null && __isset.consumerSecret) {
          field.Name = "consumerSecret";
          field.Type = TType.String;
          field.ID = 4;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.consumerSecret);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("authenticate_args(");
        sb.Append("username: ");
        sb.Append(this.username);
        sb.Append(",password: ");
        sb.Append(this.password);
        sb.Append(",consumerKey: ");
        sb.Append(this.consumerKey);
        sb.Append(",consumerSecret: ");
        sb.Append(this.consumerSecret);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class authenticate_result : TBase
    {
      private AuthenticationResult success;
      private Evernote.EDAM.Error.EDAMUserException userException;
      private Evernote.EDAM.Error.EDAMSystemException systemException;

      public AuthenticationResult Success
      {
        get
        {
          return success;
        }
        set
        {
          __isset.success = true;
          this.success = value;
        }
      }

      public Evernote.EDAM.Error.EDAMUserException UserException
      {
        get
        {
          return userException;
        }
        set
        {
          __isset.userException = true;
          this.userException = value;
        }
      }

      public Evernote.EDAM.Error.EDAMSystemException SystemException
      {
        get
        {
          return systemException;
        }
        set
        {
          __isset.systemException = true;
          this.systemException = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool success;
        public bool userException;
        public bool systemException;
      }

      public authenticate_result() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 0:
              if (field.Type == TType.Struct) {
                this.success = new AuthenticationResult();
                this.success.Read(iprot);
                this.__isset.success = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 1:
              if (field.Type == TType.Struct) {
                this.userException = new Evernote.EDAM.Error.EDAMUserException();
                this.userException.Read(iprot);
                this.__isset.userException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.Struct) {
                this.systemException = new Evernote.EDAM.Error.EDAMSystemException();
                this.systemException.Read(iprot);
                this.__isset.systemException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("authenticate_result");
        oprot.WriteStructBegin(struc);
        TField field = new TField();

        if (this.__isset.success) {
          if (this.success != null) {
            field.Name = "success";
            field.Type = TType.Struct;
            field.ID = 0;
            oprot.WriteFieldBegin(field);
            this.success.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.userException) {
          if (this.userException != null) {
            field.Name = "userException";
            field.Type = TType.Struct;
            field.ID = 1;
            oprot.WriteFieldBegin(field);
            this.userException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.systemException) {
          if (this.systemException != null) {
            field.Name = "systemException";
            field.Type = TType.Struct;
            field.ID = 2;
            oprot.WriteFieldBegin(field);
            this.systemException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("authenticate_result(");
        sb.Append("success: ");
        sb.Append(this.success== null ? "<null>" : this.success.ToString());
        sb.Append(",userException: ");
        sb.Append(this.userException== null ? "<null>" : this.userException.ToString());
        sb.Append(",systemException: ");
        sb.Append(this.systemException== null ? "<null>" : this.systemException.ToString());
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class refreshAuthentication_args : TBase
    {
      private string authenticationToken;

      public string AuthenticationToken
      {
        get
        {
          return authenticationToken;
        }
        set
        {
          __isset.authenticationToken = true;
          this.authenticationToken = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool authenticationToken;
      }

      public refreshAuthentication_args() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 1:
              if (field.Type == TType.String) {
                this.authenticationToken = iprot.ReadString();
                this.__isset.authenticationToken = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("refreshAuthentication_args");
        oprot.WriteStructBegin(struc);
        TField field = new TField();
        if (this.authenticationToken != null && __isset.authenticationToken) {
          field.Name = "authenticationToken";
          field.Type = TType.String;
          field.ID = 1;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.authenticationToken);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("refreshAuthentication_args(");
        sb.Append("authenticationToken: ");
        sb.Append(this.authenticationToken);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class refreshAuthentication_result : TBase
    {
      private AuthenticationResult success;
      private Evernote.EDAM.Error.EDAMUserException userException;
      private Evernote.EDAM.Error.EDAMSystemException systemException;

      public AuthenticationResult Success
      {
        get
        {
          return success;
        }
        set
        {
          __isset.success = true;
          this.success = value;
        }
      }

      public Evernote.EDAM.Error.EDAMUserException UserException
      {
        get
        {
          return userException;
        }
        set
        {
          __isset.userException = true;
          this.userException = value;
        }
      }

      public Evernote.EDAM.Error.EDAMSystemException SystemException
      {
        get
        {
          return systemException;
        }
        set
        {
          __isset.systemException = true;
          this.systemException = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool success;
        public bool userException;
        public bool systemException;
      }

      public refreshAuthentication_result() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 0:
              if (field.Type == TType.Struct) {
                this.success = new AuthenticationResult();
                this.success.Read(iprot);
                this.__isset.success = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 1:
              if (field.Type == TType.Struct) {
                this.userException = new Evernote.EDAM.Error.EDAMUserException();
                this.userException.Read(iprot);
                this.__isset.userException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.Struct) {
                this.systemException = new Evernote.EDAM.Error.EDAMSystemException();
                this.systemException.Read(iprot);
                this.__isset.systemException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("refreshAuthentication_result");
        oprot.WriteStructBegin(struc);
        TField field = new TField();

        if (this.__isset.success) {
          if (this.success != null) {
            field.Name = "success";
            field.Type = TType.Struct;
            field.ID = 0;
            oprot.WriteFieldBegin(field);
            this.success.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.userException) {
          if (this.userException != null) {
            field.Name = "userException";
            field.Type = TType.Struct;
            field.ID = 1;
            oprot.WriteFieldBegin(field);
            this.userException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.systemException) {
          if (this.systemException != null) {
            field.Name = "systemException";
            field.Type = TType.Struct;
            field.ID = 2;
            oprot.WriteFieldBegin(field);
            this.systemException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("refreshAuthentication_result(");
        sb.Append("success: ");
        sb.Append(this.success== null ? "<null>" : this.success.ToString());
        sb.Append(",userException: ");
        sb.Append(this.userException== null ? "<null>" : this.userException.ToString());
        sb.Append(",systemException: ");
        sb.Append(this.systemException== null ? "<null>" : this.systemException.ToString());
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class getUser_args : TBase
    {
      private string authenticationToken;

      public string AuthenticationToken
      {
        get
        {
          return authenticationToken;
        }
        set
        {
          __isset.authenticationToken = true;
          this.authenticationToken = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool authenticationToken;
      }

      public getUser_args() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 1:
              if (field.Type == TType.String) {
                this.authenticationToken = iprot.ReadString();
                this.__isset.authenticationToken = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("getUser_args");
        oprot.WriteStructBegin(struc);
        TField field = new TField();
        if (this.authenticationToken != null && __isset.authenticationToken) {
          field.Name = "authenticationToken";
          field.Type = TType.String;
          field.ID = 1;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.authenticationToken);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("getUser_args(");
        sb.Append("authenticationToken: ");
        sb.Append(this.authenticationToken);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class getUser_result : TBase
    {
      private Evernote.EDAM.Type.User success;
      private Evernote.EDAM.Error.EDAMUserException userException;
      private Evernote.EDAM.Error.EDAMSystemException systemException;

      public Evernote.EDAM.Type.User Success
      {
        get
        {
          return success;
        }
        set
        {
          __isset.success = true;
          this.success = value;
        }
      }

      public Evernote.EDAM.Error.EDAMUserException UserException
      {
        get
        {
          return userException;
        }
        set
        {
          __isset.userException = true;
          this.userException = value;
        }
      }

      public Evernote.EDAM.Error.EDAMSystemException SystemException
      {
        get
        {
          return systemException;
        }
        set
        {
          __isset.systemException = true;
          this.systemException = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool success;
        public bool userException;
        public bool systemException;
      }

      public getUser_result() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 0:
              if (field.Type == TType.Struct) {
                this.success = new Evernote.EDAM.Type.User();
                this.success.Read(iprot);
                this.__isset.success = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 1:
              if (field.Type == TType.Struct) {
                this.userException = new Evernote.EDAM.Error.EDAMUserException();
                this.userException.Read(iprot);
                this.__isset.userException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.Struct) {
                this.systemException = new Evernote.EDAM.Error.EDAMSystemException();
                this.systemException.Read(iprot);
                this.__isset.systemException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("getUser_result");
        oprot.WriteStructBegin(struc);
        TField field = new TField();

        if (this.__isset.success) {
          if (this.success != null) {
            field.Name = "success";
            field.Type = TType.Struct;
            field.ID = 0;
            oprot.WriteFieldBegin(field);
            this.success.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.userException) {
          if (this.userException != null) {
            field.Name = "userException";
            field.Type = TType.Struct;
            field.ID = 1;
            oprot.WriteFieldBegin(field);
            this.userException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.systemException) {
          if (this.systemException != null) {
            field.Name = "systemException";
            field.Type = TType.Struct;
            field.ID = 2;
            oprot.WriteFieldBegin(field);
            this.systemException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("getUser_result(");
        sb.Append("success: ");
        sb.Append(this.success== null ? "<null>" : this.success.ToString());
        sb.Append(",userException: ");
        sb.Append(this.userException== null ? "<null>" : this.userException.ToString());
        sb.Append(",systemException: ");
        sb.Append(this.systemException== null ? "<null>" : this.systemException.ToString());
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class getPublicUserInfo_args : TBase
    {
      private string username;

      public string Username
      {
        get
        {
          return username;
        }
        set
        {
          __isset.username = true;
          this.username = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool username;
      }

      public getPublicUserInfo_args() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 1:
              if (field.Type == TType.String) {
                this.username = iprot.ReadString();
                this.__isset.username = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("getPublicUserInfo_args");
        oprot.WriteStructBegin(struc);
        TField field = new TField();
        if (this.username != null && __isset.username) {
          field.Name = "username";
          field.Type = TType.String;
          field.ID = 1;
          oprot.WriteFieldBegin(field);
          oprot.WriteString(this.username);
          oprot.WriteFieldEnd();
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("getPublicUserInfo_args(");
        sb.Append("username: ");
        sb.Append(this.username);
        sb.Append(")");
        return sb.ToString();
      }

    }


    [Serializable]
    public partial class getPublicUserInfo_result : TBase
    {
      private PublicUserInfo success;
      private Evernote.EDAM.Error.EDAMNotFoundException notFoundException;
      private Evernote.EDAM.Error.EDAMSystemException systemException;
      private Evernote.EDAM.Error.EDAMUserException userException;

      public PublicUserInfo Success
      {
        get
        {
          return success;
        }
        set
        {
          __isset.success = true;
          this.success = value;
        }
      }

      public Evernote.EDAM.Error.EDAMNotFoundException NotFoundException
      {
        get
        {
          return notFoundException;
        }
        set
        {
          __isset.notFoundException = true;
          this.notFoundException = value;
        }
      }

      public Evernote.EDAM.Error.EDAMSystemException SystemException
      {
        get
        {
          return systemException;
        }
        set
        {
          __isset.systemException = true;
          this.systemException = value;
        }
      }

      public Evernote.EDAM.Error.EDAMUserException UserException
      {
        get
        {
          return userException;
        }
        set
        {
          __isset.userException = true;
          this.userException = value;
        }
      }


      public Isset __isset;
      [Serializable]
      public struct Isset {
        public bool success;
        public bool notFoundException;
        public bool systemException;
        public bool userException;
      }

      public getPublicUserInfo_result() {
      }

      public void Read (TProtocol iprot)
      {
        TField field;
        iprot.ReadStructBegin();
        while (true)
        {
          field = iprot.ReadFieldBegin();
          if (field.Type == TType.Stop) { 
            break;
          }
          switch (field.ID)
          {
            case 0:
              if (field.Type == TType.Struct) {
                this.success = new PublicUserInfo();
                this.success.Read(iprot);
                this.__isset.success = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 1:
              if (field.Type == TType.Struct) {
                this.notFoundException = new Evernote.EDAM.Error.EDAMNotFoundException();
                this.notFoundException.Read(iprot);
                this.__isset.notFoundException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 2:
              if (field.Type == TType.Struct) {
                this.systemException = new Evernote.EDAM.Error.EDAMSystemException();
                this.systemException.Read(iprot);
                this.__isset.systemException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            case 3:
              if (field.Type == TType.Struct) {
                this.userException = new Evernote.EDAM.Error.EDAMUserException();
                this.userException.Read(iprot);
                this.__isset.userException = true;
              } else { 
                TProtocolUtil.Skip(iprot, field.Type);
              }
              break;
            default: 
              TProtocolUtil.Skip(iprot, field.Type);
              break;
          }
          iprot.ReadFieldEnd();
        }
        iprot.ReadStructEnd();
      }

      public void Write(TProtocol oprot) {
        TStruct struc = new TStruct("getPublicUserInfo_result");
        oprot.WriteStructBegin(struc);
        TField field = new TField();

        if (this.__isset.success) {
          if (this.success != null) {
            field.Name = "success";
            field.Type = TType.Struct;
            field.ID = 0;
            oprot.WriteFieldBegin(field);
            this.success.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.notFoundException) {
          if (this.notFoundException != null) {
            field.Name = "notFoundException";
            field.Type = TType.Struct;
            field.ID = 1;
            oprot.WriteFieldBegin(field);
            this.notFoundException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.systemException) {
          if (this.systemException != null) {
            field.Name = "systemException";
            field.Type = TType.Struct;
            field.ID = 2;
            oprot.WriteFieldBegin(field);
            this.systemException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        } else if (this.__isset.userException) {
          if (this.userException != null) {
            field.Name = "userException";
            field.Type = TType.Struct;
            field.ID = 3;
            oprot.WriteFieldBegin(field);
            this.userException.Write(oprot);
            oprot.WriteFieldEnd();
          }
        }
        oprot.WriteFieldStop();
        oprot.WriteStructEnd();
      }

      public override string ToString() {
        StringBuilder sb = new StringBuilder("getPublicUserInfo_result(");
        sb.Append("success: ");
        sb.Append(this.success== null ? "<null>" : this.success.ToString());
        sb.Append(",notFoundException: ");
        sb.Append(this.notFoundException== null ? "<null>" : this.notFoundException.ToString());
        sb.Append(",systemException: ");
        sb.Append(this.systemException== null ? "<null>" : this.systemException.ToString());
        sb.Append(",userException: ");
        sb.Append(this.userException== null ? "<null>" : this.userException.ToString());
        sb.Append(")");
        return sb.ToString();
      }

    }

  }
}
